__gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > Class Template Reference
Extensions » Policy-Based Data Structures » Containers » Branch-Based » Base and Policy Classes

`#include <ov_tree_map_.hpp>`

Inheritance diagram for __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >:
[legend]

## Classes

class | cond_dtor

## Public Types

typedef _Alloc | allocator_type
typedef Cmp_Fn | cmp_fn
typedef std::pair< size_type, size_type > | comp_hash
typedef point_const_iterator | const_iterator
typedef traits_base::const_pointer | const_pointer
typedef traits_base::const_reference | const_reference
typedef ov_tree_tag | container_category
typedef _Alloc::difference_type | difference_type
typedef point_iterator | iterator
typedef traits_base::key_const_pointer | key_const_pointer
typedef traits_base::key_const_reference | key_const_reference
typedef traits_base::key_pointer | key_pointer
typedef traits_base::key_reference | key_reference
typedef traits_base::key_type | key_type
typedef traits_base::mapped_const_pointer | mapped_const_pointer
typedef traits_base::mapped_const_reference | mapped_const_reference
typedef traits_base::mapped_pointer | mapped_pointer
typedef traits_base::mapped_reference | mapped_reference
typedef traits_base::mapped_type | mapped_type
typedef __nothrowcopy::indicator | no_throw_indicator
typedef traits_type::node_const_iterator | node_const_iterator
typedef traits_type::node_iterator | node_iterator
typedef traits_type::node_update | node_update
typedef const_pointer | point_const_iterator
typedef pointer | point_iterator
typedef traits_base::pointer | pointer
typedef traits_base::reference | reference
typedef _Alloc::size_type | size_type
typedef integral_constant< int, Store_Hash > | store_extra
typedef stored_data< value_type, size_type, Store_Hash > | stored_data_type
typedef traits_base::value_type | value_type

## Public Member Functions

| ov_tree_map (const Cmp_Fn &)
| ov_tree_map (const Cmp_Fn &, const node_update &)
| ov_tree_map (const ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
iterator | begin ()
const_iterator | begin () const
void | clear ()
template<typename It>
void | copy_from_range (It, It)
bool | empty () const
iterator | end ()
const_iterator | end () const
iterator | erase (iterator it)
bool | erase (key_const_reference)
template<typename Pred>
size_type | erase_if (Pred)
point_iterator | find (key_const_reference r_key)
point_const_iterator | find (key_const_reference r_key) const
Cmp_Fn & | get_cmp_fn ()
const Cmp_Fn & | get_cmp_fn () const
std::pair< point_iterator, bool > | insert (const_reference r_value)
void | join (ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
point_iterator | lower_bound (key_const_reference r_key)
point_const_iterator | lower_bound (key_const_reference r_key) const
size_type | max_size () const
node_iterator | node_begin ()
node_const_iterator | node_begin () const
node_iterator | node_end ()
node_const_iterator | node_end () const
mapped_reference | operator[] (key_const_reference r_key)
size_type | size () const
void | split (key_const_reference, ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
void | swap (ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
point_iterator | upper_bound (key_const_reference r_key)
point_const_iterator | upper_bound (key_const_reference r_key) const

## Public Attributes

no_throw_indicator | m_no_throw_copies_indicator
store_extra | m_store_extra_indicator

## Detailed Description

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>
class __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >

Ordered-vector tree associative-container.

Definition at line 106 of file ov_tree_map_.hpp.

## Member Typedef Documentation

## allocator_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef _Alloc __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::allocator_type

Definition at line 151 of file ov_tree_map_.hpp.

## cmp_fn

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef Cmp_Fn __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::cmp_fn

Definition at line 154 of file ov_tree_map_.hpp.

## comp_hash

typedef std::pair<size_type, size_type> __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::comp_hash

inherited

Definition at line 187 of file types_traits.hpp.

## const_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef point_const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_iterator

Definition at line 180 of file ov_tree_map_.hpp.

## const_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::const_pointer __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_pointer

Definition at line 168 of file ov_tree_map_.hpp.

## const_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::const_reference __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_reference

Definition at line 170 of file ov_tree_map_.hpp.

## container_category

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef ov_tree_tag __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::container_category

Definition at line 150 of file ov_tree_map_.hpp.

## difference_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef _Alloc::difference_type __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::difference_type

Definition at line 153 of file ov_tree_map_.hpp.

## iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef point_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::iterator

Definition at line 179 of file ov_tree_map_.hpp.

## key_const_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::key_const_pointer __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_const_pointer

Definition at line 158 of file ov_tree_map_.hpp.

## key_const_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::key_const_reference __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_const_reference

Definition at line 160 of file ov_tree_map_.hpp.

## key_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::key_pointer __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_pointer

Definition at line 157 of file ov_tree_map_.hpp.

## key_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::key_reference __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_reference

Definition at line 159 of file ov_tree_map_.hpp.

## key_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::key_type __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_type

Definition at line 156 of file ov_tree_map_.hpp.

## mapped_const_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::mapped_const_pointer __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_const_pointer

Definition at line 163 of file ov_tree_map_.hpp.

## mapped_const_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::mapped_const_reference __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_const_reference

Definition at line 165 of file ov_tree_map_.hpp.

## mapped_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::mapped_pointer __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_pointer

Definition at line 162 of file ov_tree_map_.hpp.

## mapped_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::mapped_reference __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_reference

Definition at line 164 of file ov_tree_map_.hpp.

## mapped_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::mapped_type __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_type

Definition at line 161 of file ov_tree_map_.hpp.

## no_throw_indicator

typedef __nothrowcopy::indicator __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::no_throw_indicator

inherited

Definition at line 189 of file types_traits.hpp.

## node_const_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_type::node_const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_const_iterator

Definition at line 221 of file ov_tree_map_.hpp.

## node_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_type::node_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_iterator

Definition at line 220 of file ov_tree_map_.hpp.

## node_update

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_type::node_update __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_update

Definition at line 219 of file ov_tree_map_.hpp.

## point_const_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef const_pointer __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_const_iterator

Definition at line 172 of file ov_tree_map_.hpp.

## point_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef pointer __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_iterator

Definition at line 174 of file ov_tree_map_.hpp.

## pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::pointer __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::pointer

Definition at line 167 of file ov_tree_map_.hpp.

## reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::reference __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::reference

Definition at line 169 of file ov_tree_map_.hpp.

## size_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef _Alloc::size_type __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size_type

Definition at line 152 of file ov_tree_map_.hpp.

## store_extra

typedef integral_constant<int, Store_Hash> __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::store_extra

inherited

Definition at line 188 of file types_traits.hpp.

## stored_data_type

typedef stored_data<value_type, size_type, Store_Hash> __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::stored_data_type

inherited

Definition at line 181 of file types_traits.hpp.

## value_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_base::value_type __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::value_type

Definition at line 166 of file ov_tree_map_.hpp.

## Constructor & Destructor Documentation

## ov_tree_map() [1/4]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

__gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::ov_tree_map | ( |  | ) |

Definition at line 53 of file ov_tree_map_.hpp.

## ov_tree_map() [2/4]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

__gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::ov_tree_map | ( | const Cmp_Fn & | r_cmp_fn | ) |

Definition at line 62 of file ov_tree_map_.hpp.

## ov_tree_map() [3/4]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

__gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::ov_tree_map | ( | const Cmp_Fn & | r_cmp_fn,
|  | const node_update & | r_nodeu )

Definition at line 72 of file ov_tree_map_.hpp.

## ov_tree_map() [4/4]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

__gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::ov_tree_map | ( | const ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |

Definition at line 83 of file ov_tree_map_.hpp.

## ~ov_tree_map()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

__gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::~ov_tree_map | ( |  | ) |

Definition at line 233 of file ov_tree_map_.hpp.

## Member Function Documentation

## begin() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::begin | ( |  | ) |

inline

Definition at line 370 of file ov_tree_map_.hpp.

## begin() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::begin | ( |  | ) | const

inline

Definition at line 374 of file ov_tree_map_.hpp.

## clear()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::clear | ( |  | ) |

Definition at line 46 of file ov_tree_map_.hpp.

## copy_from_range()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>
template<typename It>

void __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::copy_from_range | ( | It | first_it,
|  | It | last_it )

inline

Definition at line 102 of file ov_tree_map_.hpp.

## empty()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bool __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::empty | ( |  | ) | const

inline nodiscard

Definition at line 62 of file ov_tree_map_.hpp.

## end() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::end | ( |  | ) |

inline

Definition at line 378 of file ov_tree_map_.hpp.

## end() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::end | ( |  | ) | const

inline

Definition at line 382 of file ov_tree_map_.hpp.

## erase() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::erase | ( | iterator | it | ) |

inline

Definition at line 357 of file ov_tree_map_.hpp.

## erase() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bool __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::erase | ( | key_const_reference | r_key | ) |

Definition at line 186 of file ov_tree_map_.hpp.

## erase_if()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>
template<typename Pred>

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size_type __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::erase_if | ( | Pred | pred | ) |

inline

Definition at line 70 of file ov_tree_map_.hpp.

## find() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

point_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::find | ( | key_const_reference | r_key | ) |

inline

Definition at line 331 of file ov_tree_map_.hpp.

## find() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

point_const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::find | ( | key_const_reference | r_key | ) | const

inline

Definition at line 346 of file ov_tree_map_.hpp.

## get_cmp_fn() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

Cmp_Fn & __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::get_cmp_fn | ( |  | ) |

Definition at line 46 of file ov_tree_map_.hpp.

## get_cmp_fn() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

const Cmp_Fn & __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::get_cmp_fn | ( |  | ) | const

Definition at line 52 of file ov_tree_map_.hpp.

## insert()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

std::pair< point_iterator, bool > __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::insert | ( | const_reference | r_value | ) |

inline

Definition at line 276 of file ov_tree_map_.hpp.

## join()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::join | ( | ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |

Definition at line 96 of file ov_tree_map_.hpp.

## lower_bound() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

point_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::lower_bound | ( | key_const_reference | r_key | ) |

inline

Definition at line 293 of file ov_tree_map_.hpp.

## lower_bound() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

point_const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::lower_bound | ( | key_const_reference | r_key | ) | const

inline

Definition at line 309 of file ov_tree_map_.hpp.

## max_size()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size_type __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::max_size | ( |  | ) | const

inline

Definition at line 55 of file ov_tree_map_.hpp.

## node_begin() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_begin | ( |  | ) |

inline

Returns a node_iterator corresponding to the node at the root of the tree.

Definition at line 58 of file ov_tree_map_.hpp.

## node_begin() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_begin | ( |  | ) | const

inline

Returns a const node_iterator corresponding to the node at the root of the tree.

Definition at line 46 of file ov_tree_map_.hpp.

## node_end() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_end | ( |  | ) |

inline

Returns a node_iterator corresponding to a node just after a leaf of the tree.

Definition at line 64 of file ov_tree_map_.hpp.

## node_end() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_end | ( |  | ) | const

inline

Returns a const node_iterator corresponding to a node just after a leaf of the tree.

Definition at line 52 of file ov_tree_map_.hpp.

## operator[]()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

mapped_reference __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::operator[] | ( | key_const_reference | r_key | ) |

inline

Definition at line 257 of file ov_tree_map_.hpp.

## size()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size_type __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size | ( |  | ) | const

inline

Definition at line 46 of file ov_tree_map_.hpp.

## split()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::split | ( | key_const_reference | r_key,
|  | ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other )

Definition at line 46 of file ov_tree_map_.hpp.

## swap()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::swap | ( | ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |

Definition at line 206 of file ov_tree_map_.hpp.

## upper_bound() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

point_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::upper_bound | ( | key_const_reference | r_key | ) |

inline

Definition at line 313 of file ov_tree_map_.hpp.

## upper_bound() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

point_const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::upper_bound | ( | key_const_reference | r_key | ) | const

inline

Definition at line 327 of file ov_tree_map_.hpp.

## Member Data Documentation

## m_no_throw_copies_indicator

no_throw_indicator __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::m_no_throw_copies_indicator

inherited

Definition at line 192 of file types_traits.hpp.

## m_store_extra_indicator

store_extra __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::m_store_extra_indicator

inherited

Definition at line 191 of file types_traits.hpp.

The documentation for this class was generated from the following file:

- ov_tree_map_.hpp